﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DlpLibDemo;
using Nautilus;

namespace DlpLibDemo
{
	public partial class MainForm : Form, IDisposable
	{
        public static string  scannedText = "";
		SerialReader reader;
		Config cfg = Config.Default;

        DriverLicense _dl = new DriverLicense();

		public MainForm()
		{
			InitializeComponent();
			Text = Application.ProductName;
			cfg.SettingChanging += Default_SettingChanging;
			InitializeMenu();

		}

		void UnsubscribeAll()
		{
			UnsubscribeReader();
			cfg.SettingChanging -= Default_SettingChanging;
		}

		void Default_SettingChanging(object sender, System.Configuration.SettingChangingEventArgs e)
		{
			((ApplicationSettingsBase)sender).Save();
		}

		private void InitializeMenu()
		{
			var names = System.IO.Ports.SerialPort.GetPortNames();
			serialPorts.Items.AddRange(names);
			if (names.Contains(cfg.SerialPort))
				serialPorts.SelectedItem = cfg.SerialPort;
		}




		private void InitializeReadingDevice()
		{
			string device = cfg.SerialPort;
			try
			{
				if (String.IsNullOrEmpty(device) && !TrySerialPort(out device)) return;

				UnsubscribeReader();
				reader = new SerialReader(device);
				reader.Loaded += OnDataLoaded;
			}
			catch (IOException ex)
			{
				string message = ex.Message;
				MessageBox.Show(message, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}








		protected bool TrySerialPort(out string device)
		{
			device = String.Empty;
			var ports = System.IO.Ports.SerialPort.GetPortNames();
			switch (ports.Length)
			{
				case 0:
					MessageBox.Show(Strings.SerialPortNotFound
						, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error);
					return false;
				case 1:
					cfg.SerialPort = ports[0];
					device = ports[0];
					return true;
				default:
					MessageBox.Show(Strings.SelectSerialPort
						, Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Warning);
					return false;
			}
		}




        private void UnsubscribeReader()
        {
            if (reader != null)
            {
                reader.Loaded -= OnDataLoaded;
                reader.Dispose();
            }
        }

        public void MM() { MessageBox.Show("l;'"); }


		public void OnDataLoaded(object sender, EventArgs<string> e)
		{
		/*	var dl = new DriverLicense();
			if (dl.ExtractInfo(e.Data))
			{
				if (InvokeRequired)
					Invoke(new MethodInvoker(() => licenses.Add(new DriverLicensePresenter(dl))));
				else 
					licenses.Add(new DriverLicensePresenter(dl));
			}*/
		}


		private void serialPorts_SelectedIndexChanged(object sender, EventArgs e)
		{
			Config.Default.SerialPort = serialPorts.SelectedItem.ToString();
			InitializeReadingDevice();
		}

        private void MainForm_Load(object sender, EventArgs e)
        {
            _computerId.Text = DriverLicense.ComputerId;
      
        }

        private void _openBtn_Click(object sender, EventArgs e)
        {
            //    MessageBox.Show( scannedText );
            //_dl.KeyboardReader = false;
            bool res = _dl.ExtractInfo(scannedText);
            if (!res)
            {
              //  _dl.KeyboardReader = !_dl.KeyboardReader;
                res = _dl.ExtractInfo(scannedText);
            }

            if (!res)
                MessageBox.Show("Error", "Cannot parse the driver license");
            else
                tbf.Text = _dl.FirstName;
                tbl.Text = _dl.LastName;
                _address.Text = _dl.Address1;
        }

        private void _okBtn_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void cOMPortsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void selectCOMportToolStripMenuItem_MouseMove(object sender, MouseEventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }
	}
}
